module Tree where
data Tree a =  Leaf a
              | Node2 (Tree a, a, Tree a)
              | Node3 (Tree a, a, Tree a, a, Tree a)
    deriving (Eq,Read,Show)

data NodeSplit a =   Up a 
                 | Ok a

insert x t = 
    case (nodeinsert x t) of
      (Up nt) -> nt
      (Ok nt) -> nt


nodeinsert x (Leaf s) = 
    if  x == s  then Ok (Leaf s)
    else if x<s then Up (Node2 ((Leaf x), x, (Leaf s)))
    else Up (Node2 ((Leaf s), s, (Leaf x)))

nodeinsert x (Node2 (p0,s,p1)) =
    if x<=s 
    then case (nodeinsert x p0) of
           (Up (Node2 (p00,s0,p01))) -> 
                       Ok (Node3 (p00,s0,p01,s,p1))
           (Ok np0) -> Ok (Node2 (np0,s,p1))
    else case (nodeinsert x p1) of
           (Up (Node2 (p10,s1,p11))) -> 
                       Ok (Node3 (p0,s,p10,s1,p11))
           (Ok np1) -> Ok (Node2 (p0,s,np1))

nodeinsert x (Node3 (p0,s1,p1,s2,p2)) = 
    if x<=s1
    then case (nodeinsert x p0) of
           (Up (Node2 (p00,ns0,p01))) -> 
               Up (Node2 (Node2 (p00,ns0,p01),
                          s1,
                          Node2 (p1,s2,p2)))
           (Ok np0) -> Ok (Node3 (np0,s1,p1,s2,p2))
    else if x<=s2
    then case (nodeinsert x p1) of
           (Up (Node2 (p10,ns1,p11))) -> 
               Up (Node2 (Node2 (p0,s1,p10),
                          ns1,
                          Node2 (p11,s2,p2)))
           (Ok np1) -> Ok (Node3 (p0,s1,np1,s2,p2))
    else case (nodeinsert x p2) of
           (Up (Node2 (p20,ns2,p21))) -> 
               Up (Node2 (Node2 (p0,s1,p1),
                   s2,
                   Node2 (p20,ns2,p21)))
           (Ok np2) -> Ok (Node3 (p0,s1,p1,s2,np2))

